//
// Transaction.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Transaction: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var userId: Int?
    public var propertyId: Int?
    public var type: String?
    public var detailsViewed: Bool?
    public var imagesViewed: Int?
    public var timeToDecision: Int?
    public var filter: String?
    public var session: String?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var user: User?
    public var property: Property?

    public init(id: Int? = nil, userId: Int? = nil, propertyId: Int? = nil, type: String? = nil, detailsViewed: Bool? = nil, imagesViewed: Int? = nil, timeToDecision: Int? = nil, filter: String? = nil, session: String? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, user: User? = nil, property: Property? = nil) {
        self.id = id
        self.userId = userId
        self.propertyId = propertyId
        self.type = type
        self.detailsViewed = detailsViewed
        self.imagesViewed = imagesViewed
        self.timeToDecision = timeToDecision
        self.filter = filter
        self.session = session
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.user = user
        self.property = property
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case userId
        case propertyId
        case type
        case detailsViewed
        case imagesViewed
        case timeToDecision
        case filter
        case session
        case updatedAt
        case createdAt
        case user = "User"
        case property = "Property"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(userId, forKey: .userId)
        try container.encodeIfPresent(propertyId, forKey: .propertyId)
        try container.encodeIfPresent(type, forKey: .type)
        try container.encodeIfPresent(detailsViewed, forKey: .detailsViewed)
        try container.encodeIfPresent(imagesViewed, forKey: .imagesViewed)
        try container.encodeIfPresent(timeToDecision, forKey: .timeToDecision)
        try container.encodeIfPresent(filter, forKey: .filter)
        try container.encodeIfPresent(session, forKey: .session)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(user, forKey: .user)
        try container.encodeIfPresent(property, forKey: .property)
    }
}

